#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2200five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five22004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five22004xi = {
                1: '-1004x389y1918z',
                2: '-103x666y2094z',
                3: '-1041x341y1907z',
                4: '-1043x1288y1446z',
                5: '-1062x1151y1544z',
                6: '-1075x1806y648z',
                7: '-1076x292y1896z',
                8: '-1108x239y1885z',
                9: '-1119x1242y1429z',
                10: '-1132x1104y1528z',
                11: '-1137x183y1873z',
                12: '-114x12y2196z',
                13: '-1164x126y1862z',
                14: '-1172x1752y627z',
                15: '-1188x66y1850z',
                16: '-1192x1192y1412z',
                17: '-1200x1054y1512z',
                18: '-1208x3y1838z',
                19: '-1263x1137y1395z',
                20: '-1265x999y1496z',
                21: '-1266x1693y606z',
                22: '-1328x940y1480z',
                23: '-1332x1078y1378z',
                24: '-1356x1629y585z',
                25: '-137x7y2195z',
                26: '-1387x877y1464z',
                27: '-1398x1015y1361z',
                28: '-142x680y2087z',
                29: '-1444x1560y564z',
                30: '-1444x810y1447z',
                31: '-1460x948y1343z',
                32: '-1498x740y1431z',
                33: '-1519x877y1326z',
                34: '-1527x1486y542z',
                35: '-1547x666y1414z',
                36: '-155x1481y1619z',
                37: '-1575x802y1308z',
                38: '-1593x589y1397z',
                39: '-159x0y2194z',
                40: '-1607x1408y521z',
                41: '-1627x724y1291z',
                42: '-1635x509y1380z',
                43: '-1673x426y1363z',
                44: '-1674x642y1273z',
                45: '-1683x1325y500z',
                46: '-1706x340y1345z',
                47: '-1718x558y1255z',
                48: '-1735x252y1328z',
                49: '-1754x1238y478z',
                50: '-1757x470y1237z',
                51: '-1759x162y1310z',
                52: '-1791x380y1218z',
                53: '-1820x1147y457z',
                54: '-1820x288y1200z',
                55: '-183x692y2080z',
                56: '-1845x193y1181z',
                57: '-1859x74y1351z',
                58: '-1864x97y1163z',
                59: '-1878x0y1144z',
                60: '-1881x1052y435z',
                61: '-1938x954y414z',
                62: '-1989x853y392z',
                63: '-2034x749y370z',
                64: '-2074x643y349z',
                65: '-2108x534y327z',
                66: '-2137x424y305z',
                67: '-2159x312y283z',
                68: '-2175x198y261z',
                69: '-2185x84y240z',
                70: '-225x701y2072z',
                71: '-234x1367y1707z',
                72: '-235x1486y1604z',
                73: '-241x2029y814z',
                74: '-269x707y2065z',
                75: '-26x8y2199z',
                76: '-309x1370y1693z',
                77: '-314x711y2057z',
                78: '-316x1488y1589z',
                79: '-348x2021y794z',
                80: '-360x712y2049z',
                81: '-384x1368y1679z',
                82: '-397x1484y1573z',
                83: '-407x710y2041z',
                84: '-454x705y2033z',
                85: '-455x2008y773z',
                86: '-461x1362y1664z',
                87: '-479x1476y1558z',
                88: '-47x13y2199z',
                89: '-503x697y2025z',
                90: '-538x1351y1650z',
                91: '-551x685y2016z',
                92: '-562x1464y1542z',
                93: '-562x1989y752z',
                94: '-5x2y2199z',
                95: '-600x670y2007z',
                96: '-614x1336y1635z',
                97: '-644x1446y1527z',
                98: '-648x652y1998z',
                99: '-667x1964y732z',
                100: '-66x649y2100z',
                101: '-691x1316y1620z',
                102: '-696x631y1989z',
                103: '-69x15y2198z',
                104: '-725x1424y1511z',
                105: '-744x606y1979z',
                106: '-767x1292y1605z',
                107: '-772x1933y711z',
                108: '-790x578y1969z',
                109: '-806x1397y1495z',
                110: '-836x546y1959z',
                111: '-843x1264y1590z',
                112: '-875x1896y690z',
                113: '-880x512y1949z',
                114: '-887x1366y1478z',
                115: '-917x1230y1575z',
                116: '-923x474y1939z',
                117: '-92x15y2198z',
                118: '-964x433y1929z',
                119: '-966x1329y1462z',
                120: '-976x1854y669z',
                121: '-991x1193y1560z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2200five4xi" usage = "target function for charge22004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2200five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2200FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2200FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2200FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2200FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2200FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five22004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2200FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2200FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2200FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five22004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five22004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2200FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2200FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2200FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2200five4xi.py                             
# -------------------------------------------------------------------------------------------------                